#
# spec file for package heartbeat (Version 0.4.9.1)
#
# Copyright (c) 2002 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  lynx openssl openssl-devel ucdsnmp
# usedforbuild    aaa_base aaa_dir aaa_version base bash bindutil bison bzip cpio cpp cyrus-sasl db devs diffutils e2fsprogs file fileutils findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm gppshare grep groff gzip kbd less m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam-devel pam-modules patch ps rcs readline sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim autoconf automake binutils cracklib gcc gdbm gettext libtool libz lynx openssl openssl-devel pam perl rpm ucdsnmp

Name:         heartbeat
Version:      0.4.9.1
Release:      159
Group:        Productivity/Clustering/HA
License:      GPL
Summary:      heartbeat subsystem for High-Availability Linux
URL:          http://linux-ha.org/
Source0:      heartbeat-0.4.9.1.tar.bz2
Patch0:       heartbeat-suse.dif
Patch1:       heartbeat-ia64.dif
Patch2:       heartbeat-wti.dif
Patch3:       heartbeat-apcmastersnmp.dif
Patch4:       heartbeat-secfix.dif
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
heartbeat is a basic heartbeat subsystem for Linux-HA.
It will run scripts at initialization, and when machines go up or down.
This version will also perform IP address takeover using gratuitous ARPs.
It works correctly for a 2-node configuration, and is extensible to larger
configurations.

It implements the following kinds of heartbeats:

- Bidirectional Serial Rings ("raw" serial ports)
- UDP/IP braodcast (ethernet, etc)
- Bidirectional Serial PPP/UDP Rings (using PPP)

Authors:
--------
    Alan Robertson <alanr@suse.com>
    Volker Wiegand <Volker.Wiegand@suse.de>
    Rudy Pawul <rpawul@iso-ne.com>
    Mitja Sarp <mitja@lysator.liu.se>
    Guenther Thomsen <thomsen@cs.tu-berlin.de>
    Jacob Rief <jacob.rief@tis.at>
    Luis Claudio R. Gonalves <lclaudio@conectiva.com.br>
    Marcelo Tosatti <marcelo@conectiva.com.br>
    Horms <horms@vergenet.net>

SuSE series: ap

%package ldirectd
Summary:      Monitor daemon for maintaining high availability resources
Group:        Productivity/Clustering/HA
# These are the right perl module names, but the wrong package names.
# Requires: LWP.pm, Net::SSLeay get yours from ultramonkey.sourceforge.net
Requires:     perl-Net_SSLeay perl-libwww-perl

%description ldirectd
The Linux Director Daemon (ldirectord) was written by Jacob Rief
<jacob.rief@tiscover.com>

The ldirectord is a stand-alone daemon to monitor services of real
servers, currently http, https and ftp service. It is simple to
install and works with the heartbeat code (http://www.linux-ha.org/).

See 'ldirectord -h' for all the information about ldirectord.
See linux-ha/doc/ldirectord for more information.

Authors:
--------
    Jacob Rief <jacob.rief@tiscover.com>

SuSE series: ap

%package stonith
Summary:      Provides an interface to Shoot The Other Node In The Head
Group:        Productivity/Clustering/HA
Requires:     telnet

%description stonith
The STONITH module (a.k.a. STOMITH) provides an extensible interface
for remotely powering down a node in the cluster.  The idea is quite simple:
When the software running on one machine wants to make sure another
machine in the cluster is not using a resource, pull the plug on the other
machine. It's simple and reliable, albeit admittedly brutal.

Authors:
--------
    Alan Robertson <alanr@suse.com>

SuSE series: ap

%prep
%setup
%patch0
%ifarch ia64
%patch1
%endif
%patch2
%patch3
%patch4

%build
rm rc.config.heartbeat
make

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/" ] && rm -rf "$RPM_BUILD_ROOT"
RPM_BUILD=yes BUILD_ROOT=$RPM_BUILD_ROOT MAN_DIR=$RPM_BUILD_ROOT/%{_mandir} \
	make -e install
test -d $RPM_BUILD_ROOT/sbin || mkdir $RPM_BUILD_ROOT/sbin
ln -s ../etc/init.d/heartbeat  $RPM_BUILD_ROOT/sbin/rcheartbeat
ln -s ../etc/init.d/ldirectord $RPM_BUILD_ROOT/sbin/rcldirectord 
ln -s ../../../usr/sbin/ldirectord $RPM_BUILD_ROOT/etc/ha.d/resource.d/ldirectord
mkdir -p $RPM_BUILD_ROOT/%{_defaultdocdir}/heartbeat/stonith

%files
%defattr(-,root,root)
%dir /etc/ha.d
%dir /etc/ha.d/conf
%dir /etc/ha.d/rc.d
%dir /etc/ha.d/resource.d
%dir /usr/lib/heartbeat
%dir /usr/lib/heartbeat/modules
%dir /usr/lib/heartbeat/modules/auth
%dir /usr/lib/heartbeat/modules/comm
%config /etc/init.d/heartbeat
/etc/ha.d/README.config
/etc/ha.d/harc
/etc/ha.d/shellfuncs
/etc/ha.d/rc.d/ifstat
/etc/ha.d/rc.d/ip-request
/etc/ha.d/rc.d/ip-request-resp
/etc/ha.d/rc.d/ns_st
/etc/ha.d/rc.d/shutdone
/etc/ha.d/rc.d/status
/etc/ha.d/resource.d/AudibleAlarm
/etc/ha.d/resource.d/Filesystem
/etc/ha.d/resource.d/IPaddr
/etc/ha.d/resource.d/Raid1
/etc/logrotate.d/heartbeat
/usr/lib/libhbclient.so
/usr/lib/libhbclient.a
/usr/lib/heartbeat/ResourceManager
/usr/lib/heartbeat/api_test
/usr/lib/heartbeat/findif
/usr/lib/heartbeat/heartbeat
/usr/lib/heartbeat/mach_down
/usr/lib/heartbeat/modules/auth/crc.so
/usr/lib/heartbeat/modules/auth/md5.so
/usr/lib/heartbeat/modules/auth/sha1.so
/usr/lib/heartbeat/modules/comm/mcast.so
/usr/lib/heartbeat/modules/comm/ping.so
/usr/lib/heartbeat/modules/comm/serial.so
/usr/lib/heartbeat/modules/comm/udp.so
/usr/lib/heartbeat/req_resource
/usr/lib/heartbeat/send_arp
/sbin/rcheartbeat
%dir /var/lib/heartbeat
%dir /var/run/ppp.d
%attr (600, root,  root)     /var/lib/heartbeat/fifo
%attr (750, root,  haclient) /var/lib/heartbeat/api
%attr (620, root,  haclient) /var/lib/heartbeat/register
%attr (1770, root, haclient) /var/lib/heartbeat/casual
%doc doc/*

%files ldirectd
%defattr(-,root,root)
/etc/ha.d/resource.d/ldirectord
/usr/sbin/ldirectord
/etc/logrotate.d/ldirectord
/sbin/rcldirectord
%config /etc/init.d/ldirectord
%doc %{_mandir}/man8/ldirectord.8*
%doc ldirectord/ldirectord.cf

%files stonith
%defattr(-,root,root)
%dir /usr/lib/stonith
/usr/include/stonith.h
/usr/lib/libstonith.a
/usr/lib/libstonith.so
/usr/lib/stonith/*.so
/usr/sbin/meatclient
/usr/sbin/stonith
%doc stonith/README* stonith/*.cfg.example
#%clean
#rm -rf $RPM_BUILD_ROOT
#rm -rf $RPM_BUILD_DIR/heartbeat-0.4.9

%pre
if
  grep '^haclient:' etc/group >/dev/null
then
  : OK group haclient already present
else
  GROUPOPT="-g 90"
  if
    chroot . /usr/sbin/groupadd $GROUPOPT haclient
  then
    : OK we were able to add group haclient
  else
    chroot . /usr/sbin/groupadd haclient
  fi
fi

%post
#
#	Hack to allow ppp-udp to be notified about PPP processes starting
#
Install_PPP_hack() {
  file2hack=etc/ppp/ip-up.local
  echo "NOTE: Modifying $file2hack"
  if [ ! -f $file2hack ] ; then
    echo '#!/bin/bash' > $file2hack
    chmod 755 $file2hack
  fi
  MARKER="Heartbeat"
  ed -s $file2hack <<-!EOF  2>/dev/null
H
g/ $MARKER\$/d
\$a
# The following lines added for Linux-HA support             # $MARKER
DEVFILE=\`echo \$DEVICE | sed -e 's!^/dev/!!' -e 's!/!.!g'\` # $MARKER
OUTFILE=/var/run/ppp.d/\$DEVFILE                             # $MARKER
(                    # $MARKER
echo "\$IPREMOTE"    # $MARKER
echo "\$IFNAME"      # $MARKER
echo "\$PPPD_PID"    # $MARKER
echo "\$IPLOCAL"     # $MARKER
) > \$OUTFILE        # $MARKER
.
w
!EOF
}
if [ ! -x etc/ppp/ip-up.heart ] ; then
  Install_PPP_hack
fi
%{fillup_and_insserv heartbeat}

%preun
Uninstall_PPP_hack() {
  file2hack=etc/ppp/ip-up.local
  echo "NOTE: Restoring $file2hack"
  MARKER="Heartbeat"
  ed -s $file2hack <<-!EOF  2>/dev/null
H
g/ $MARKER\$/d
w
!EOF
}
if [ ! -x etc/ppp/ip-up.heart ] ; then
  Uninstall_PPP_hack
fi

%postun
%{insserv_cleanup}

%changelog -n heartbeat
* Mon Oct 14 2002 - lmb@suse.de
- Fix for format string vulnerabilities.
* Mon Feb 18 2002 - jg@suse.de
- fixed heartbeat init script for LSB compliance
- fixed ldirectord init script for LSB compliance (Bug #12403)
- using GID 90 for group haclient now
* Thu Jan 31 2002 - jg@suse.de
- updated apcmastersnmp STONITH module to CVS version
* Thu Dec 20 2001 - ro@suse.de
- removed START_HEARTBEAT from startscript
- fixed insserv calls
* Thu Dec 20 2001 - jg@suse.de
- Update to 0.4.9.1
- removed insserv calls and rc-link creation from specfile
- added insserv macros to specfile
- added wti_nps module from linux-ha cvs
* Thu Oct 04 2001 - jg@suse.de
- added ia64 patch
* Wed Sep 19 2001 - jg@suse.de
- Update to 0.4.9
- added SSH reset module
- Build root works now (using patches from HBV)
* Tue Feb 20 2001 - uli@suse.de
- fixed for new glibc
* Thu Jan 18 2001 - ro@suse.de
- next occurence of old gid
* Thu Jan 18 2001 - ro@suse.de
- changed gid to 65 all over
* Tue Jan 16 2001 - ro@suse.de
- changed group-id to 65 (60 is already used)
* Tue Jan 16 2001 - mt@suse.de
- deleted '' characters in spec file
* Tue Dec 19 2000 - uli@suse.de
- added openssl to neededforbuild (needed by lynx)
* Fri Dec 01 2000 - ro@suse.de
- init-script move to /etc/init.d
* Wed Nov 22 2000 - mt@suse.de
- changed to LSB installation of run level scripts
* Fri Nov 17 2000 - mt@suse.de
- updated to newest version 0.4.8i
* Wed Nov 15 2000 - mt@suse.de
- updated to newest version 0.4.8h
* Wed Nov 08 2000 - mt@suse.de
- added patch to not to install docs from makefile - rpm does it
* Wed Nov 08 2000 - mt@suse.de
- new package
